Index: uspace/drv/block/ata_bd/ata_bd.c
===================================================================
--- uspace/drv/block/ata_bd/ata_bd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/block/ata_bd/ata_bd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -82,41 +82,41 @@
 static const size_t identify_data_size = 512;
 
-static errno_t ata_bd_init_io(ata_ctrl_t *ctrl);
+static int ata_bd_init_io(ata_ctrl_t *ctrl);
 static void ata_bd_fini_io(ata_ctrl_t *ctrl);
 
-static errno_t ata_bd_open(bd_srvs_t *, bd_srv_t *);
-static errno_t ata_bd_close(bd_srv_t *);
-static errno_t ata_bd_read_blocks(bd_srv_t *, uint64_t ba, size_t cnt, void *buf,
+static int ata_bd_open(bd_srvs_t *, bd_srv_t *);
+static int ata_bd_close(bd_srv_t *);
+static int ata_bd_read_blocks(bd_srv_t *, uint64_t ba, size_t cnt, void *buf,
     size_t);
-static errno_t ata_bd_read_toc(bd_srv_t *, uint8_t session, void *buf, size_t);
-static errno_t ata_bd_write_blocks(bd_srv_t *, uint64_t ba, size_t cnt,
+static int ata_bd_read_toc(bd_srv_t *, uint8_t session, void *buf, size_t);
+static int ata_bd_write_blocks(bd_srv_t *, uint64_t ba, size_t cnt,
     const void *buf, size_t);
-static errno_t ata_bd_get_block_size(bd_srv_t *, size_t *);
-static errno_t ata_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
-static errno_t ata_bd_sync_cache(bd_srv_t *, aoff64_t, size_t);
-
-static errno_t ata_rcmd_read(disk_t *disk, uint64_t ba, size_t cnt,
+static int ata_bd_get_block_size(bd_srv_t *, size_t *);
+static int ata_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
+static int ata_bd_sync_cache(bd_srv_t *, aoff64_t, size_t);
+
+static int ata_rcmd_read(disk_t *disk, uint64_t ba, size_t cnt,
     void *buf);
-static errno_t ata_rcmd_write(disk_t *disk, uint64_t ba, size_t cnt,
+static int ata_rcmd_write(disk_t *disk, uint64_t ba, size_t cnt,
     const void *buf);
-static errno_t ata_rcmd_flush_cache(disk_t *disk);
-static errno_t disk_init(ata_ctrl_t *ctrl, disk_t *d, int disk_id);
-static errno_t ata_identify_dev(disk_t *disk, void *buf);
-static errno_t ata_identify_pkt_dev(disk_t *disk, void *buf);
-static errno_t ata_cmd_packet(disk_t *disk, const void *cpkt, size_t cpkt_size,
+static int ata_rcmd_flush_cache(disk_t *disk);
+static int disk_init(ata_ctrl_t *ctrl, disk_t *d, int disk_id);
+static int ata_identify_dev(disk_t *disk, void *buf);
+static int ata_identify_pkt_dev(disk_t *disk, void *buf);
+static int ata_cmd_packet(disk_t *disk, const void *cpkt, size_t cpkt_size,
     void *obuf, size_t obuf_size, size_t *rcvd_size);
-static errno_t ata_pcmd_inquiry(disk_t *disk, void *obuf, size_t obuf_size,
+static int ata_pcmd_inquiry(disk_t *disk, void *obuf, size_t obuf_size,
     size_t *rcvd_size);
-static errno_t ata_pcmd_read_12(disk_t *disk, uint64_t ba, size_t cnt,
+static int ata_pcmd_read_12(disk_t *disk, uint64_t ba, size_t cnt,
     void *obuf, size_t obuf_size);
-static errno_t ata_pcmd_read_capacity(disk_t *disk, uint64_t *nblocks,
+static int ata_pcmd_read_capacity(disk_t *disk, uint64_t *nblocks,
     size_t *block_size);
-static errno_t ata_pcmd_read_toc(disk_t *disk, uint8_t ses,
+static int ata_pcmd_read_toc(disk_t *disk, uint8_t ses,
     void *obuf, size_t obuf_size);
 static void disk_print_summary(disk_t *d);
-static errno_t coord_calc(disk_t *d, uint64_t ba, block_coord_t *bc);
+static int coord_calc(disk_t *d, uint64_t ba, block_coord_t *bc);
 static void coord_sc_program(ata_ctrl_t *ctrl, const block_coord_t *bc,
     uint16_t scnt);
-static errno_t wait_status(ata_ctrl_t *ctrl, unsigned set, unsigned n_reset,
+static int wait_status(ata_ctrl_t *ctrl, unsigned set, unsigned n_reset,
     uint8_t *pstatus, unsigned timeout);
 
@@ -143,8 +143,7 @@
 
 /** Initialize ATA controller. */
-errno_t ata_ctrl_init(ata_ctrl_t *ctrl, ata_base_t *res)
-{
-	int i;
-	errno_t rc;
+int ata_ctrl_init(ata_ctrl_t *ctrl, ata_base_t *res)
+{
+	int i, rc;
 	int n_disks;
 
@@ -209,8 +208,7 @@
 
 /** Remove ATA controller. */
-errno_t ata_ctrl_remove(ata_ctrl_t *ctrl)
-{
-	int i;
-	errno_t rc;
+int ata_ctrl_remove(ata_ctrl_t *ctrl)
+{
+	int i, rc;
 
 	ddf_msg(LVL_DEBUG, ": ata_ctrl_remove()");
@@ -234,8 +232,7 @@
 
 /** Surprise removal of ATA controller. */
-errno_t ata_ctrl_gone(ata_ctrl_t *ctrl)
-{
-	int i;
-	errno_t rc;
+int ata_ctrl_gone(ata_ctrl_t *ctrl)
+{
+	int i, rc;
 
 	ddf_msg(LVL_DEBUG, "ata_ctrl_gone()");
@@ -308,7 +305,7 @@
 
 /** Enable device I/O. */
-static errno_t ata_bd_init_io(ata_ctrl_t *ctrl)
-{
-	errno_t rc;
+static int ata_bd_init_io(ata_ctrl_t *ctrl)
+{
+	int rc;
 	void *vaddr;
 
@@ -344,5 +341,5 @@
  * the disk structure.
  */
-static errno_t disk_init(ata_ctrl_t *ctrl, disk_t *d, int disk_id)
+static int disk_init(ata_ctrl_t *ctrl, disk_t *d, int disk_id)
 {
 	identify_data_t idata;
@@ -356,5 +353,5 @@
 	size_t block_size;
 	size_t pos, len;
-	errno_t rc;
+	int rc;
 	unsigned i;
 
@@ -498,10 +495,10 @@
 }
 
-static errno_t ata_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
-{
-	return EOK;
-}
-
-static errno_t ata_bd_close(bd_srv_t *bd)
+static int ata_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
+{
+	return EOK;
+}
+
+static int ata_bd_close(bd_srv_t *bd)
 {
 	return EOK;
@@ -509,9 +506,9 @@
 
 /** Read multiple blocks from the device. */
-static errno_t ata_bd_read_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt,
+static int ata_bd_read_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt,
     void *buf, size_t size)
 {
 	disk_t *disk = bd_srv_disk(bd);
-	errno_t rc;
+	int rc;
 
 	if (size < cnt * disk->block_size)
@@ -538,5 +535,5 @@
 
 /** Read TOC from device. */
-static errno_t ata_bd_read_toc(bd_srv_t *bd, uint8_t session, void *buf, size_t size)
+static int ata_bd_read_toc(bd_srv_t *bd, uint8_t session, void *buf, size_t size)
 {
 	disk_t *disk = bd_srv_disk(bd);
@@ -546,9 +543,9 @@
 
 /** Write multiple blocks to the device. */
-static errno_t ata_bd_write_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt,
+static int ata_bd_write_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt,
     const void *buf, size_t size)
 {
 	disk_t *disk = bd_srv_disk(bd);
-	errno_t rc;
+	int rc;
 
 	if (disk->dev_type != ata_reg_dev)
@@ -572,5 +569,5 @@
 
 /** Get device block size. */
-static errno_t ata_bd_get_block_size(bd_srv_t *bd, size_t *rbsize)
+static int ata_bd_get_block_size(bd_srv_t *bd, size_t *rbsize)
 {
 	disk_t *disk = bd_srv_disk(bd);
@@ -581,5 +578,5 @@
 
 /** Get device number of blocks. */
-static errno_t ata_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
+static int ata_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
 {
 	disk_t *disk = bd_srv_disk(bd);
@@ -590,5 +587,5 @@
 
 /** Flush cache. */
-static errno_t ata_bd_sync_cache(bd_srv_t *bd, uint64_t ba, size_t cnt)
+static int ata_bd_sync_cache(bd_srv_t *bd, uint64_t ba, size_t cnt)
 {
 	disk_t *disk = bd_srv_disk(bd);
@@ -602,5 +599,5 @@
 
 /** PIO data-in command protocol. */
-static errno_t ata_pio_data_in(disk_t *disk, void *obuf, size_t obuf_size,
+static int ata_pio_data_in(disk_t *disk, void *obuf, size_t obuf_size,
     size_t blk_size, size_t nblocks)
 {
@@ -633,5 +630,5 @@
 
 /** PIO data-out command protocol. */
-static errno_t ata_pio_data_out(disk_t *disk, const void *buf, size_t buf_size,
+static int ata_pio_data_out(disk_t *disk, const void *buf, size_t buf_size,
     size_t blk_size, size_t nblocks)
 {
@@ -662,5 +659,5 @@
 
 /** PIO non-data command protocol. */
-static errno_t ata_pio_nondata(disk_t *disk)
+static int ata_pio_nondata(disk_t *disk)
 {
 	ata_ctrl_t *ctrl = disk->ctrl;
@@ -687,5 +684,5 @@
  *			not present). EIO if device responds with error.
  */
-static errno_t ata_identify_dev(disk_t *disk, void *buf)
+static int ata_identify_dev(disk_t *disk, void *buf)
 {
 	ata_ctrl_t *ctrl = disk->ctrl;
@@ -739,5 +736,5 @@
  * @param buf		Pointer to a 512-byte buffer.
  */
-static errno_t ata_identify_pkt_dev(disk_t *disk, void *buf)
+static int ata_identify_pkt_dev(disk_t *disk, void *buf)
 {
 	ata_ctrl_t *ctrl = disk->ctrl;
@@ -772,5 +769,5 @@
  * @return EOK on success, EIO on error.
  */
-static errno_t ata_cmd_packet(disk_t *disk, const void *cpkt, size_t cpkt_size,
+static int ata_cmd_packet(disk_t *disk, const void *cpkt, size_t cpkt_size,
     void *obuf, size_t obuf_size, size_t *rcvd_size)
 {
@@ -860,10 +857,10 @@
  * @return EOK on success, EIO on error.
  */
-static errno_t ata_pcmd_inquiry(disk_t *disk, void *obuf, size_t obuf_size,
+static int ata_pcmd_inquiry(disk_t *disk, void *obuf, size_t obuf_size,
     size_t *rcvd_size)
 {
 	uint8_t cpb[12];
 	scsi_cdb_inquiry_t *cp = (scsi_cdb_inquiry_t *)cpb;
-	errno_t rc;
+	int rc;
 
 	memset(cpb, 0, sizeof(cpb));
@@ -893,5 +890,5 @@
  * @return EOK on success, EIO on error.
  */
-static errno_t ata_pcmd_read_capacity(disk_t *disk, uint64_t *nblocks,
+static int ata_pcmd_read_capacity(disk_t *disk, uint64_t *nblocks,
     size_t *block_size)
 {
@@ -899,5 +896,5 @@
 	scsi_read_capacity_10_data_t data;
 	size_t rsize;
-	errno_t rc;
+	int rc;
 
 	memset(&cdb, 0, sizeof(cdb));
@@ -930,9 +927,9 @@
  * @return EOK on success, EIO on error.
  */
-static errno_t ata_pcmd_read_12(disk_t *disk, uint64_t ba, size_t cnt,
+static int ata_pcmd_read_12(disk_t *disk, uint64_t ba, size_t cnt,
     void *obuf, size_t obuf_size)
 {
 	scsi_cdb_read_12_t cp;
-	errno_t rc;
+	int rc;
 
 	if (ba > UINT32_MAX)
@@ -969,10 +966,10 @@
  * @return EOK on success, EIO on error.
  */
-static errno_t ata_pcmd_read_toc(disk_t *disk, uint8_t session, void *obuf,
+static int ata_pcmd_read_toc(disk_t *disk, uint8_t session, void *obuf,
     size_t obuf_size)
 {
 	uint8_t cpb[12];
 	scsi_cdb_read_toc_t *cp = (scsi_cdb_read_toc_t *)cpb;
-	errno_t rc;
+	int rc;
 
 	memset(cpb, 0, sizeof(cpb));
@@ -1001,5 +998,5 @@
  * @return EOK on success, EIO on error.
  */
-static errno_t ata_rcmd_read(disk_t *disk, uint64_t ba, size_t blk_cnt,
+static int ata_rcmd_read(disk_t *disk, uint64_t ba, size_t blk_cnt,
     void *buf)
 {
@@ -1007,5 +1004,5 @@
 	uint8_t drv_head;
 	block_coord_t bc;
-	errno_t rc;
+	int rc;
 
 	/* Silence warning. */
@@ -1061,5 +1058,5 @@
  * @return EOK on success, EIO on error.
  */
-static errno_t ata_rcmd_write(disk_t *disk, uint64_t ba, size_t cnt,
+static int ata_rcmd_write(disk_t *disk, uint64_t ba, size_t cnt,
     const void *buf)
 {
@@ -1067,5 +1064,5 @@
 	uint8_t drv_head;
 	block_coord_t bc;
-	errno_t rc;
+	int rc;
 
 	/* Silence warning. */
@@ -1117,9 +1114,9 @@
  * @return EOK on success, EIO on error.
  */
-static errno_t ata_rcmd_flush_cache(disk_t *disk)
+static int ata_rcmd_flush_cache(disk_t *disk)
 {
 	ata_ctrl_t *ctrl = disk->ctrl;
 	uint8_t drv_head;
-	errno_t rc;
+	int rc;
 
 	/* New value for Drive/Head register */
@@ -1159,5 +1156,5 @@
  * @return EOK on success or EINVAL if block index is past end of device.
  */
-static errno_t coord_calc(disk_t *d, uint64_t ba, block_coord_t *bc)
+static int coord_calc(disk_t *d, uint64_t ba, block_coord_t *bc)
 {
 	uint64_t c;
@@ -1246,5 +1243,5 @@
  * @return		EOK on success, EIO on timeout.
  */
-static errno_t wait_status(ata_ctrl_t *ctrl, unsigned set, unsigned n_reset,
+static int wait_status(ata_ctrl_t *ctrl, unsigned set, unsigned n_reset,
     uint8_t *pstatus, unsigned timeout)
 {
Index: uspace/drv/block/ata_bd/ata_bd.h
===================================================================
--- uspace/drv/block/ata_bd/ata_bd.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/block/ata_bd/ata_bd.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -153,7 +153,7 @@
 } ata_fun_t;
 
-extern errno_t ata_ctrl_init(ata_ctrl_t *, ata_base_t *);
-extern errno_t ata_ctrl_remove(ata_ctrl_t *);
-extern errno_t ata_ctrl_gone(ata_ctrl_t *);
+extern int ata_ctrl_init(ata_ctrl_t *, ata_base_t *);
+extern int ata_ctrl_remove(ata_ctrl_t *);
+extern int ata_ctrl_gone(ata_ctrl_t *);
 
 extern bd_ops_t ata_bd_ops;
Index: uspace/drv/block/ata_bd/main.c
===================================================================
--- uspace/drv/block/ata_bd/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/block/ata_bd/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,9 +41,9 @@
 #include "main.h"
 
-static errno_t ata_dev_add(ddf_dev_t *dev);
-static errno_t ata_dev_remove(ddf_dev_t *dev);
-static errno_t ata_dev_gone(ddf_dev_t *dev);
-static errno_t ata_fun_online(ddf_fun_t *fun);
-static errno_t ata_fun_offline(ddf_fun_t *fun);
+static int ata_dev_add(ddf_dev_t *dev);
+static int ata_dev_remove(ddf_dev_t *dev);
+static int ata_dev_gone(ddf_dev_t *dev);
+static int ata_fun_online(ddf_fun_t *fun);
+static int ata_fun_offline(ddf_fun_t *fun);
 
 static void ata_bd_connection(ipc_callid_t, ipc_call_t *, void *);
@@ -62,9 +62,9 @@
 };
 
-static errno_t ata_get_res(ddf_dev_t *dev, ata_base_t *ata_res)
+static int ata_get_res(ddf_dev_t *dev, ata_base_t *ata_res)
 {
 	async_sess_t *parent_sess;
 	hw_res_list_parsed_t hw_res;
-	errno_t rc;
+	int rc;
 
 	parent_sess = ddf_dev_parent_sess_get(dev);
@@ -106,11 +106,11 @@
  *
  * @param  dev New device
- * @return     EOK on success or an error code.
+ * @return     EOK on success or negative error code.
  */
-static errno_t ata_dev_add(ddf_dev_t *dev)
+static int ata_dev_add(ddf_dev_t *dev)
 {
 	ata_ctrl_t *ctrl;
 	ata_base_t res;
-	errno_t rc;
+	int rc;
 
 	rc = ata_get_res(dev, &res);
@@ -151,8 +151,8 @@
 }
 
-errno_t ata_fun_create(disk_t *disk)
+int ata_fun_create(disk_t *disk)
 {
 	ata_ctrl_t *ctrl = disk->ctrl;
-	errno_t rc;
+	int rc;
 	char *fun_name = NULL;
 	ddf_fun_t *fun = NULL;
@@ -212,7 +212,7 @@
 }
 
-errno_t ata_fun_remove(disk_t *disk)
-{
-	errno_t rc;
+int ata_fun_remove(disk_t *disk)
+{
+	int rc;
 	char *fun_name;
 
@@ -250,7 +250,7 @@
 }
 
-errno_t ata_fun_unbind(disk_t *disk)
-{
-	errno_t rc;
+int ata_fun_unbind(disk_t *disk)
+{
+	int rc;
 	char *fun_name;
 
@@ -282,5 +282,5 @@
 }
 
-static errno_t ata_dev_remove(ddf_dev_t *dev)
+static int ata_dev_remove(ddf_dev_t *dev)
 {
 	ata_ctrl_t *ctrl = (ata_ctrl_t *)ddf_dev_data_get(dev);
@@ -291,5 +291,5 @@
 }
 
-static errno_t ata_dev_gone(ddf_dev_t *dev)
+static int ata_dev_gone(ddf_dev_t *dev)
 {
 	ata_ctrl_t *ctrl = (ata_ctrl_t *)ddf_dev_data_get(dev);
@@ -300,5 +300,5 @@
 }
 
-static errno_t ata_fun_online(ddf_fun_t *fun)
+static int ata_fun_online(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "ata_fun_online()");
@@ -306,5 +306,5 @@
 }
 
-static errno_t ata_fun_offline(ddf_fun_t *fun)
+static int ata_fun_offline(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "ata_fun_offline()");
Index: uspace/drv/block/ata_bd/main.h
===================================================================
--- uspace/drv/block/ata_bd/main.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/block/ata_bd/main.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,7 +38,7 @@
 #include "ata_bd.h"
 
-extern errno_t ata_fun_create(disk_t *);
-extern errno_t ata_fun_remove(disk_t *);
-extern errno_t ata_fun_unbind(disk_t *);
+extern int ata_fun_create(disk_t *);
+extern int ata_fun_remove(disk_t *);
+extern int ata_fun_unbind(disk_t *);
 
 #endif
Index: uspace/drv/block/ddisk/ddisk.c
===================================================================
--- uspace/drv/block/ddisk/ddisk.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/block/ddisk/ddisk.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,9 +56,9 @@
 #define DDISK_CMD_IRQ_DEASSERT	0x4
 
-static errno_t ddisk_dev_add(ddf_dev_t *);
-static errno_t ddisk_dev_remove(ddf_dev_t *);
-static errno_t ddisk_dev_gone(ddf_dev_t *);
-static errno_t ddisk_fun_online(ddf_fun_t *);
-static errno_t ddisk_fun_offline(ddf_fun_t *);
+static int ddisk_dev_add(ddf_dev_t *);
+static int ddisk_dev_remove(ddf_dev_t *);
+static int ddisk_dev_gone(ddf_dev_t *);
+static int ddisk_fun_online(ddf_fun_t *);
+static int ddisk_fun_offline(ddf_fun_t *);
 
 static void ddisk_bd_connection(ipc_callid_t, ipc_call_t *, void *);
@@ -117,11 +117,11 @@
 } ddisk_t;
 
-static errno_t ddisk_bd_open(bd_srvs_t *, bd_srv_t *);
-static errno_t ddisk_bd_close(bd_srv_t *);
-static errno_t ddisk_bd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
-static errno_t ddisk_bd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *,
+static int ddisk_bd_open(bd_srvs_t *, bd_srv_t *);
+static int ddisk_bd_close(bd_srv_t *);
+static int ddisk_bd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
+static int ddisk_bd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *,
     size_t);
-static errno_t ddisk_bd_get_block_size(bd_srv_t *, size_t *);
-static errno_t ddisk_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
+static int ddisk_bd_get_block_size(bd_srv_t *, size_t *);
+static int ddisk_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
 
 bd_ops_t ddisk_bd_ops = {
@@ -188,10 +188,10 @@
 }
 
-errno_t ddisk_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
-{
-	return EOK;
-}
-
-errno_t ddisk_bd_close(bd_srv_t *bd)
+int ddisk_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
+{
+	return EOK;
+}
+
+int ddisk_bd_close(bd_srv_t *bd)
 {
 	return EOK;
@@ -199,5 +199,5 @@
 
 static
-errno_t ddisk_rw_block(ddisk_t *ddisk, bool read, aoff64_t ba, void *buf)
+int ddisk_rw_block(ddisk_t *ddisk, bool read, aoff64_t ba, void *buf)
 {
 	fibril_mutex_lock(&ddisk->lock);
@@ -236,10 +236,10 @@
 
 static
-errno_t ddisk_bd_rw_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt, void *buf,
+int ddisk_bd_rw_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt, void *buf,
     size_t size, bool is_read)
 {
 	ddisk_t *ddisk = (ddisk_t *) bd->srvs->sarg;
 	aoff64_t i;
-	errno_t rc;
+	int rc;
 
 	if (size < cnt * DDISK_BLOCK_SIZE)
@@ -256,5 +256,5 @@
 }
 
-errno_t ddisk_bd_read_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt, void *buf,
+int ddisk_bd_read_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt, void *buf,
     size_t size)
 {
@@ -262,5 +262,5 @@
 }
 
-errno_t ddisk_bd_write_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt,
+int ddisk_bd_write_blocks(bd_srv_t *bd, aoff64_t ba, size_t cnt,
     const void *buf, size_t size)
 {
@@ -268,5 +268,5 @@
 }
 
-errno_t ddisk_bd_get_block_size(bd_srv_t *bd, size_t *rsize)
+int ddisk_bd_get_block_size(bd_srv_t *bd, size_t *rsize)
 {
 	*rsize = DDISK_BLOCK_SIZE; 
@@ -274,5 +274,5 @@
 }
 
-errno_t ddisk_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
+int ddisk_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
 {
 	ddisk_t *ddisk = (ddisk_t *) bd->srvs->sarg;
@@ -282,9 +282,9 @@
 }
 
-static errno_t ddisk_get_res(ddf_dev_t *dev, ddisk_res_t *ddisk_res)
+static int ddisk_get_res(ddf_dev_t *dev, ddisk_res_t *ddisk_res)
 {
 	async_sess_t *parent_sess;
 	hw_res_list_parsed_t hw_res;
-	errno_t rc;
+	int rc;
 
 	parent_sess = ddf_dev_parent_sess_get(dev);
@@ -317,7 +317,7 @@
 }
 
-static errno_t ddisk_fun_create(ddisk_t *ddisk)
-{
-	errno_t rc;
+static int ddisk_fun_create(ddisk_t *ddisk)
+{
+	int rc;
 	ddf_fun_t *fun = NULL;
 
@@ -350,7 +350,7 @@
 }
 
-static errno_t ddisk_fun_remove(ddisk_t *ddisk)
-{
-	errno_t rc;
+static int ddisk_fun_remove(ddisk_t *ddisk)
+{
+	int rc;
 
 	if (ddisk->fun == NULL)
@@ -381,7 +381,7 @@
 }
 
-static errno_t ddisk_fun_unbind(ddisk_t *ddisk)
-{
-	errno_t rc;
+static int ddisk_fun_unbind(ddisk_t *ddisk)
+{
+	int rc;
 
 	if (ddisk->fun == NULL)
@@ -408,11 +408,11 @@
  *
  * @param  dev New device
- * @return     EOK on success or an error code.
+ * @return     EOK on success or negative error code.
  */
-static errno_t ddisk_dev_add(ddf_dev_t *dev)
+static int ddisk_dev_add(ddf_dev_t *dev)
 {
 	ddisk_t *ddisk;
 	ddisk_res_t res;
-	errno_t rc;
+	int rc;
 
 	/*
@@ -503,7 +503,8 @@
 	ddisk_irq_commands[0].addr = (void *) &res_phys->status;
 	ddisk_irq_commands[3].addr = (void *) &res_phys->command;
-	rc = register_interrupt_handler(dev, ddisk->ddisk_res.irq,
-	    ddisk_irq_handler, &ddisk_irq_code, &ddisk->irq_cap);
-	if (rc != EOK) {
+	ddisk->irq_cap = register_interrupt_handler(dev, ddisk->ddisk_res.irq,
+	    ddisk_irq_handler, &ddisk_irq_code);
+	if (ddisk->irq_cap < 0) {
+		rc = ddisk->irq_cap;
 		ddf_msg(LVL_ERROR, "Failed to register interrupt handler.");
 		goto error;
@@ -530,7 +531,7 @@
 
 
-static errno_t ddisk_dev_remove_common(ddisk_t *ddisk, bool surprise)
-{
-	errno_t rc;
+static int ddisk_dev_remove_common(ddisk_t *ddisk, bool surprise)
+{
+	int rc;
 
 	if (!surprise)
@@ -558,5 +559,5 @@
 }
 
-static errno_t ddisk_dev_remove(ddf_dev_t *dev)
+static int ddisk_dev_remove(ddf_dev_t *dev)
 {
 	ddisk_t *ddisk = (ddisk_t *) ddf_dev_data_get(dev);
@@ -566,5 +567,5 @@
 }
 
-static errno_t ddisk_dev_gone(ddf_dev_t *dev)
+static int ddisk_dev_gone(ddf_dev_t *dev)
 {
 	ddisk_t *ddisk = (ddisk_t *) ddf_dev_data_get(dev);
@@ -574,5 +575,5 @@
 }
 
-static errno_t ddisk_fun_online(ddf_fun_t *fun)
+static int ddisk_fun_online(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "ddisk_fun_online()");
@@ -580,5 +581,5 @@
 }
 
-static errno_t ddisk_fun_offline(ddf_fun_t *fun)
+static int ddisk_fun_offline(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "ddisk_fun_offline()");
Index: uspace/drv/block/usbmast/bo_trans.c
===================================================================
--- uspace/drv/block/usbmast/bo_trans.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/block/usbmast/bo_trans.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,7 +58,7 @@
  * @return		Error code
  */
-errno_t usb_massstor_cmd(usbmast_fun_t *mfun, uint32_t tag, scsi_cmd_t *cmd)
-{
-	errno_t rc;
+int usb_massstor_cmd(usbmast_fun_t *mfun, uint32_t tag, scsi_cmd_t *cmd)
+{
+	int rc;
 
 	if (cmd->data_in && cmd->data_out)
@@ -192,5 +192,5 @@
  * @return		Error code
  */
-errno_t usb_massstor_reset(usbmast_dev_t *mdev)
+int usb_massstor_reset(usbmast_dev_t *mdev)
 {
 	return usb_control_request_set(
@@ -228,5 +228,5 @@
  *
  * @param mfun		Mass storage function
- * @return		Maximum LUN (index, not count), or -1
+ * @return		Error code of maximum LUN (index, not count)
  */
 int usb_massstor_get_max_lun(usbmast_dev_t *mdev)
@@ -234,5 +234,5 @@
 	uint8_t max_lun;
 	size_t data_recv_len;
-	errno_t rc = usb_control_request_get(
+	int rc = usb_control_request_get(
 	    usb_device_get_default_pipe(mdev->usb_dev),
 	    USB_REQUEST_TYPE_CLASS, USB_REQUEST_RECIPIENT_INTERFACE,
@@ -240,10 +240,10 @@
 	    &data_recv_len);
 	if (rc != EOK) {
-		return -1;
+		return rc;
 	}
 	if (data_recv_len != 1) {
-		return -1;
-	}
-	return max_lun;
+		return EEMPTY;
+	}
+	return (int) max_lun;
 }
 
Index: uspace/drv/block/usbmast/bo_trans.h
===================================================================
--- uspace/drv/block/usbmast/bo_trans.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/block/usbmast/bo_trans.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -86,6 +86,6 @@
 } scsi_cmd_t;
 
-extern errno_t usb_massstor_cmd(usbmast_fun_t *, uint32_t, scsi_cmd_t *);
-extern errno_t usb_massstor_reset(usbmast_dev_t *);
+extern int usb_massstor_cmd(usbmast_fun_t *, uint32_t, scsi_cmd_t *);
+extern int usb_massstor_reset(usbmast_dev_t *);
 extern void usb_massstor_reset_recovery(usbmast_dev_t *);
 extern int usb_massstor_get_max_lun(usbmast_dev_t *);
Index: uspace/drv/block/usbmast/main.c
===================================================================
--- uspace/drv/block/usbmast/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/block/usbmast/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -77,15 +77,15 @@
 };
 
-static errno_t usbmast_fun_create(usbmast_dev_t *mdev, unsigned lun);
+static int usbmast_fun_create(usbmast_dev_t *mdev, unsigned lun);
 static void usbmast_bd_connection(ipc_callid_t iid, ipc_call_t *icall,
     void *arg);
 
-static errno_t usbmast_bd_open(bd_srvs_t *, bd_srv_t *);
-static errno_t usbmast_bd_close(bd_srv_t *);
-static errno_t usbmast_bd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
-static errno_t usbmast_bd_sync_cache(bd_srv_t *, aoff64_t, size_t);
-static errno_t usbmast_bd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
-static errno_t usbmast_bd_get_block_size(bd_srv_t *, size_t *);
-static errno_t usbmast_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
+static int usbmast_bd_open(bd_srvs_t *, bd_srv_t *);
+static int usbmast_bd_close(bd_srv_t *);
+static int usbmast_bd_read_blocks(bd_srv_t *, aoff64_t, size_t, void *, size_t);
+static int usbmast_bd_sync_cache(bd_srv_t *, aoff64_t, size_t);
+static int usbmast_bd_write_blocks(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
+static int usbmast_bd_get_block_size(bd_srv_t *, size_t *);
+static int usbmast_bd_get_num_blocks(bd_srv_t *, aoff64_t *);
 
 static bd_ops_t usbmast_bd_ops = {
@@ -109,5 +109,5 @@
  * @return Error code.
  */
-static errno_t usbmast_device_gone(usb_device_t *dev)
+static int usbmast_device_gone(usb_device_t *dev)
 {
 	usbmast_dev_t *mdev = usb_device_data_get(dev);
@@ -115,5 +115,5 @@
 
 	for (size_t i = 0; i < mdev->lun_count; ++i) {
-		const errno_t rc = ddf_fun_unbind(mdev->luns[i]);
+		const int rc = ddf_fun_unbind(mdev->luns[i]);
 		if (rc != EOK) {
 			usb_log_error("Failed to unbind LUN function %zu: "
@@ -133,5 +133,5 @@
  * @return Error code.
  */
-static errno_t usbmast_device_remove(usb_device_t *dev)
+static int usbmast_device_remove(usb_device_t *dev)
 {
 	//TODO: flush buffers, or whatever.
@@ -145,7 +145,7 @@
  * @return Error code.
  */
-static errno_t usbmast_device_add(usb_device_t *dev)
-{
-	errno_t rc;
+static int usbmast_device_add(usb_device_t *dev)
+{
+	int rc;
 	usbmast_dev_t *mdev = NULL;
 	unsigned i;
@@ -199,5 +199,5 @@
 		if (mdev->luns[i] == NULL)
 			continue;
-		const errno_t rc = ddf_fun_unbind(mdev->luns[i]);
+		const int rc = ddf_fun_unbind(mdev->luns[i]);
 		if (rc != EOK) {
 			usb_log_warning("Failed to unbind LUN function %zu: "
@@ -216,9 +216,9 @@
  * @param mdev		Mass storage device
  * @param lun		LUN
- * @return		EOK on success or an error code.
- */
-static errno_t usbmast_fun_create(usbmast_dev_t *mdev, unsigned lun)
-{
-	errno_t rc;
+ * @return		EOK on success or negative error code.
+ */
+static int usbmast_fun_create(usbmast_dev_t *mdev, unsigned lun)
+{
+	int rc;
 	char *fun_name = NULL;
 	ddf_fun_t *fun = NULL;
@@ -327,5 +327,5 @@
 
 /** Open device. */
-static errno_t usbmast_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
+static int usbmast_bd_open(bd_srvs_t *bds, bd_srv_t *bd)
 {
 	return EOK;
@@ -333,5 +333,5 @@
 
 /** Close device. */
-static errno_t usbmast_bd_close(bd_srv_t *bd)
+static int usbmast_bd_close(bd_srv_t *bd)
 {
 	return EOK;
@@ -339,5 +339,5 @@
 
 /** Read blocks from the device. */
-static errno_t usbmast_bd_read_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt, void *buf,
+static int usbmast_bd_read_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt, void *buf,
     size_t size)
 {
@@ -351,5 +351,5 @@
 
 /** Synchronize blocks to nonvolatile storage. */
-static errno_t usbmast_bd_sync_cache(bd_srv_t *bd, uint64_t ba, size_t cnt)
+static int usbmast_bd_sync_cache(bd_srv_t *bd, uint64_t ba, size_t cnt)
 {
 	usbmast_fun_t *mfun = bd_srv_usbmast(bd);
@@ -359,5 +359,5 @@
 
 /** Write blocks to the device. */
-static errno_t usbmast_bd_write_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt,
+static int usbmast_bd_write_blocks(bd_srv_t *bd, uint64_t ba, size_t cnt,
     const void *buf, size_t size)
 {
@@ -371,5 +371,5 @@
 
 /** Get device block size. */
-static errno_t usbmast_bd_get_block_size(bd_srv_t *bd, size_t *rsize)
+static int usbmast_bd_get_block_size(bd_srv_t *bd, size_t *rsize)
 {
 	usbmast_fun_t *mfun = bd_srv_usbmast(bd);
@@ -379,5 +379,5 @@
 
 /** Get number of blocks on device. */
-static errno_t usbmast_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
+static int usbmast_bd_get_num_blocks(bd_srv_t *bd, aoff64_t *rnb)
 {
 	usbmast_fun_t *mfun = bd_srv_usbmast(bd);
Index: uspace/drv/block/usbmast/scsi_ms.c
===================================================================
--- uspace/drv/block/usbmast/scsi_ms.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/block/usbmast/scsi_ms.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -72,9 +72,9 @@
 }
 
-static errno_t usb_massstor_unit_ready(usbmast_fun_t *mfun)
+static int usb_massstor_unit_ready(usbmast_fun_t *mfun)
 {
 	scsi_cmd_t cmd;
 	scsi_cdb_test_unit_ready_t cdb;
-	errno_t rc;
+	int rc;
 
 	memset(&cdb, 0, sizeof(cdb));
@@ -107,9 +107,9 @@
  * XXX This is too simplified.
  */
-static errno_t usbmast_run_cmd(usbmast_fun_t *mfun, scsi_cmd_t *cmd)
+static int usbmast_run_cmd(usbmast_fun_t *mfun, scsi_cmd_t *cmd)
 {
 	uint8_t sense_key;
 	scsi_sense_data_t sense_buf;
-	errno_t rc;
+	int rc;
 
 	do {
@@ -162,10 +162,10 @@
  * @return		Error code
  */
-errno_t usbmast_inquiry(usbmast_fun_t *mfun, usbmast_inquiry_data_t *inq_res)
+int usbmast_inquiry(usbmast_fun_t *mfun, usbmast_inquiry_data_t *inq_res)
 {
 	scsi_std_inquiry_data_t inq_data;
 	scsi_cmd_t cmd;
 	scsi_cdb_inquiry_t cdb;
-	errno_t rc;
+	int rc;
 
 	memset(&cdb, 0, sizeof(cdb));
@@ -231,9 +231,9 @@
  * @return		Error code.
  */
-errno_t usbmast_request_sense(usbmast_fun_t *mfun, void *buf, size_t size)
+int usbmast_request_sense(usbmast_fun_t *mfun, void *buf, size_t size)
 {
 	scsi_cmd_t cmd;
 	scsi_cdb_request_sense_t cdb;
-	errno_t rc;
+	int rc;
 
 	memset(&cdb, 0, sizeof(cdb));
@@ -272,5 +272,5 @@
  * @return		Error code.
  */
-errno_t usbmast_read_capacity(usbmast_fun_t *mfun, uint32_t *nblocks,
+int usbmast_read_capacity(usbmast_fun_t *mfun, uint32_t *nblocks,
     uint32_t *block_size)
 {
@@ -278,5 +278,5 @@
 	scsi_cdb_read_capacity_10_t cdb;
 	scsi_read_capacity_10_data_t data;
-	errno_t rc;
+	int rc;
 
 	memset(&cdb, 0, sizeof(cdb));
@@ -323,9 +323,9 @@
  * @return		Error code
  */
-errno_t usbmast_read(usbmast_fun_t *mfun, uint64_t ba, size_t nblocks, void *buf)
+int usbmast_read(usbmast_fun_t *mfun, uint64_t ba, size_t nblocks, void *buf)
 {
 	scsi_cmd_t cmd;
 	scsi_cdb_read_10_t cdb;
-	errno_t rc;
+	int rc;
 
 	if (ba > UINT32_MAX)
@@ -378,10 +378,10 @@
  * @return		Error code
  */
-errno_t usbmast_write(usbmast_fun_t *mfun, uint64_t ba, size_t nblocks,
+int usbmast_write(usbmast_fun_t *mfun, uint64_t ba, size_t nblocks,
     const void *data)
 {
 	scsi_cmd_t cmd;
 	scsi_cdb_write_10_t cdb;
-	errno_t rc;
+	int rc;
 
 	if (ba > UINT32_MAX)
@@ -428,5 +428,5 @@
  * @return		Error code
  */
-errno_t usbmast_sync_cache(usbmast_fun_t *mfun, uint64_t ba, size_t nblocks)
+int usbmast_sync_cache(usbmast_fun_t *mfun, uint64_t ba, size_t nblocks)
 {
 	if (ba > UINT32_MAX)
@@ -447,5 +447,5 @@
 	};
 
-	const errno_t rc = usbmast_run_cmd(mfun, &cmd);
+	const int rc = usbmast_run_cmd(mfun, &cmd);
 
         if (rc != EOK) {
Index: uspace/drv/block/usbmast/scsi_ms.h
===================================================================
--- uspace/drv/block/usbmast/scsi_ms.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/block/usbmast/scsi_ms.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -60,10 +60,10 @@
 } usbmast_inquiry_data_t;
 
-extern errno_t usbmast_inquiry(usbmast_fun_t *, usbmast_inquiry_data_t *);
-extern errno_t usbmast_request_sense(usbmast_fun_t *, void *, size_t);
-extern errno_t usbmast_read_capacity(usbmast_fun_t *, uint32_t *, uint32_t *);
-extern errno_t usbmast_read(usbmast_fun_t *, uint64_t, size_t, void *);
-extern errno_t usbmast_write(usbmast_fun_t *, uint64_t, size_t, const void *);
-extern errno_t usbmast_sync_cache(usbmast_fun_t *, uint64_t, size_t);
+extern int usbmast_inquiry(usbmast_fun_t *, usbmast_inquiry_data_t *);
+extern int usbmast_request_sense(usbmast_fun_t *, void *, size_t);
+extern int usbmast_read_capacity(usbmast_fun_t *, uint32_t *, uint32_t *);
+extern int usbmast_read(usbmast_fun_t *, uint64_t, size_t, void *);
+extern int usbmast_write(usbmast_fun_t *, uint64_t, size_t, const void *);
+extern int usbmast_sync_cache(usbmast_fun_t *, uint64_t, size_t);
 extern const char *usbmast_scsi_dev_type_str(unsigned);
 
